/// <reference types="sequelize" />
import * as Sequelize from 'sequelize';
import { ProviderPool } from './pool';
export interface TableCreationHook {
    (create: () => Promise<void>, database: Sequelize.Model<any, any>, context: any): Promise<void>;
}
export interface TableDestructionHook {
    (destroy: () => Promise<void>, database: Sequelize.Model<any, any>, context: any): Promise<void>;
}
export interface DatabaseAfterCreationHook {
    (database: Sequelize.Model<any, any>, context: any): Promise<void>;
}
export interface DatabaseAfterDestructionHook {
    (database: Sequelize.Model<any, any>, context: any): Promise<void>;
}
export declare function createDatabase(sequelize: Sequelize.Sequelize, pool: ProviderPool, context?: any): Promise<void>;
export declare function destroyDatabase(sequelize: Sequelize.Sequelize, pool: ProviderPool, context?: any): Promise<void>;
