/// <reference types="sequelize" />
import * as Sequelize from 'sequelize';
import { SpecType } from 'pretur.spec';
import { Query, MutateRequest } from 'pretur.sync';
import { ResolveResult } from './resolver';
import { SyncResult } from './synchronizer';
import { Provider } from './provider';
export declare type Transaction = Sequelize.Transaction;
export interface ProviderMap {
    [model: string]: Provider<any>;
}
export interface ProviderPool {
    providers: ProviderMap;
    resolve<T extends SpecType>(transaction: Transaction, model: T['name'], query: Query<T>, context?: any): Promise<ResolveResult<T>>;
    sync<T extends SpecType>(transaction: Transaction, item: MutateRequest<T>, context?: any): Promise<SyncResult<T>>;
}
export declare function buildProviderPool(...descriptors: Provider<any>[]): ProviderPool;
