import { Query } from 'pretur.sync';
import { Spec, SpecType, Model } from 'pretur.spec';
import { ProviderPool, Transaction } from './pool';
export interface ResolveResult<T extends SpecType> {
    data: Model<T>[];
    count: number;
}
export interface Resolver<T extends SpecType> {
    (transaction: Transaction, query: Query<T>, context: any): Promise<ResolveResult<T>>;
}
export interface UnitializedResolver<T extends SpecType> {
    resolver: Resolver<T>;
    initialize(pool: ProviderPool): void;
}
export interface ResolveInterceptor<T extends SpecType> {
    (resolve: (query: Query<T>) => Promise<ResolveResult<T>>, transaction: Transaction, query: Query<T>, context: any): Promise<ResolveResult<T>>;
}
export interface BuildResolverOptions<T extends SpecType> {
    interceptor?: ResolveInterceptor<T>;
}
export declare function buildResolver<T extends SpecType>(spec: Spec<T>, options?: BuildResolverOptions<T>): UnitializedResolver<T>;
